#ifndef GRID_HPP
#define GRID_HPP

template <typename T>
class square_grid
{
private:
	size_t L;
	vector<T> data;
public:
	square_grid() : L(0), data() {}
	square_grid(size_t L_) : L(L_), data(L*L) {}
	void set_length(size_t L_) { L = L_; data.resize(L*L); }
	size_t length(void) { return L; }
	T& operator()(size_t i, size_t j)
	{ 
		assert(i < L); assert(j < L); 
		return data[i+j*L]; 
	}
};

struct cell
{
	bool is_removed;
	long int cluster_membership;
};

#endif // GRID_HPP